package com.huiju.welcome.service.impl;

import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huiju.welcome.mapper.TaCarMapper;
import com.huiju.welcome.model.*;
import com.huiju.welcome.service.*;
import com.huiju.welcome.utils.CommConstant;
import com.huiju.welcome.utils.StatusUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author jobob
 * @since 2019-06-18
 */
@Service
public class TaCarServiceImpl extends ServiceImpl<TaCarMapper, TaCar> implements ITaCarService {
    Logger log = LoggerFactory.getLogger(TaCarServiceImpl.class);

    @Autowired
    private TaCarMapper taCarMapper;

    @Override
    public TaCar newCarByDevice(TaCarRecord taCarRecord) {
        String plateNumber = taCarRecord.getPlateNumber();
        if (null == plateNumber || "".equals(plateNumber)) {
            return null;
        }

        TaCar taCar = taCarMapper.selectById(plateNumber);
        if (null != taCar) return taCar;

        taCar = new TaCar();
        taCar.setPlateNumber(taCarRecord.getPlateNumber());
        taCar.setCarImage(taCarRecord.getCarImage());
        taCar.setCarModel(taCarRecord.getCarModel());
        taCar.setColor(taCarRecord.getColor());
        taCar.setTypeId(CommConstant.TYPE_CAR_NORMAL);
        taCar.setStatus(StatusUtils.Normal);
        taCar.setCreateDate(LocalDateTime.now());

        int row = taCarMapper.insert(taCar);
        if (row < 1) {
            log.error("插入车辆信息出错!");
            return null;
        }

        return taCar;
    }

    @Override
    public boolean setCarType(String id, String typeId) {
        UpdateWrapper<TaCar> updateWrapper = new UpdateWrapper<>();
        updateWrapper.set("type_id", typeId);
        updateWrapper.eq("plate_number", id);

        return taCarMapper.update(new TaCar(), updateWrapper) > 0;
    }
}
